package ar.edu.unsam.clinicaadelgazamiento.facturacion;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;

public abstract class Paciente {
	
	private Collection<Visita> visitas;
	
	public Paciente() {
		this.visitas = new ArrayList<Visita>();
	}
	
	public Collection<Visita> getVisitas() {
		return visitas;
	}

	public void agregarVisita(Visita visita) {
		this.visitas.add(visita);
	}

	public double getMontoFacturacion(Date mes) {
		double total = 0;
		for (Visita visita : this.getVisitasDelMes(mes)) {
			total += this.getMontoVisita(visita);
		}
		return total;
	}

	private Collection<Visita> getVisitasDelMes(Date mes) {
		return this.getVisitas();
	}

	protected abstract double getMontoVisita(Visita visita);

}
