package ar.edu.unsam.clinicaadelgazamiento.facturacion;

import java.util.Date;

public class PacientePlan extends Paciente {

	private Plan plan;

	@Override
	public double getMontoFacturacion(Date mes) {
		return super.getMontoFacturacion(mes) + this.plan.getTarifa();
	}

	@Override
	protected double getMontoVisita(Visita visita) {
		if (visita.getServicio().estaIncluidoEn(this.plan)) {
			return 0;
		} else {
			return visita.getMonto();
		}
	}

	public Plan getPlan() {
		return plan;
	}

	public void setPlan(Plan plan) {
		this.plan = plan;
	}

}
