package ar.edu.unsam.clinicaadelgazamiento.facturacion;


import java.util.Date;

import junit.framework.Assert;

import org.junit.Before;
import org.junit.Test;

public class TestPunto1 {

	private Paciente paciente;
	private Paciente lucas;
	private Paciente artem;
	private PacienteObraSocial paula;
	private Visita visitaSesionGimnasia;
	private Visita visitaConsulta;
	private Visita visitaReunionGrupal;
	private ConsultaClinica consultaCara;

	@Before
	public void armarFixture() {
		paciente = new PacienteEventual();
		visitaSesionGimnasia = new Visita(new SesionGimnasia());
		paciente.agregarVisita(visitaSesionGimnasia);
		lucas = new PacienteEventual();
		consultaCara = new ConsultaClinica(new Profesional(600));
		visitaConsulta = new Visita(consultaCara);
		lucas.agregarVisita(visitaConsulta);
		artem = new PacienteEventual();
		ReunionGrupal reunion = new ReunionGrupal(80);
		visitaReunionGrupal = new Visita(reunion);
		artem.agregarVisita(visitaReunionGrupal);
		paula = new PacienteObraSocial();
		ObraSocial uom = new ObraSocial();
		uom.setPorcentajeDescuentoAfiliado(0.20);
		paula.setObraSocial(uom);
		paula.agregarVisita(visitaReunionGrupal);
	}

	@Test
	public void montoUnaSesionDeGimnasia() {
		Assert.assertEquals(10.0, paciente.getMontoFacturacion(new Date()));
	}

	@Test
	public void montoDosSesionesDeGimnasia() {
		paciente.agregarVisita(visitaSesionGimnasia);
		Assert.assertEquals(20.0, paciente.getMontoFacturacion(new Date()));
	}

	@Test
	public void montoConsultaClinica() {
		Assert.assertEquals(600.0, lucas.getMontoFacturacion(new Date()));
	}

	@Test
	public void consultaClinicaCara() {
		Assert.assertTrue(consultaCara.esCara());
	}
	
	@Test
	public void reunionGrupal() {
		Assert.assertEquals(80.0, artem.getMontoFacturacion(new Date()));
	}

	@Test
	public void reunionGrupalDeObraSocial() {
		Assert.assertEquals(16.0, paula.getMontoFacturacion(new Date()));
	}

}
